﻿//-----
//DeepClone3.as by Kristoffe Brodeur.  ©2009 All Rights Reserved.
/*
02-09-2009
	added _pnt options to objects in arrays or references that are just meant as pointers so it stops endless recursive loops.
	if the program finds an object or associative array node with _pnt as an ending
	or a parent with _pnt, it will only reference to it not copy
03-14-2009
	added new functions [addBranch] and [pushCopy] for easier control with XML and branch copy control
03-27-200
	built addBranch properly for node from one array to push to another's end
*/
//-----
DeepClone.prototype.subStackChk=function()	
	{
	this._recurse++;
	//trace("subStackChk>");
	tOf=typeof(this._oldTgt);
	//trace("["+tOf+"]("+this._oldTgt+")");
	//
	switch(tOf)
		{
		//
		case("object"):
			//trace("check obj>");
			//
			len=this._stack.length;
			len2=this._stack[len-1]._subStack.length;
			tgt=this._stack[len-1]._subStack[len2-1]._nP;
			//object needs to be deepClone searched
			if(tgt==false)
				{
				//trace("REAL!");
				this.flow="stackAdd";		
				this.checkRecursion();
				}
			//object is just a pointer
			else
				{
				this.flow="subStackPop";		
				this.checkRecursion();		
				}
			break;
		//
		case("function"):
			this.flow="subStackPop";		
			this.checkRecursion();		
			break;
		//
		case("string"):
			this.flow="subStackPop";		
			this.checkRecursion();		
			break;
		//
		case("number"):
			this.flow="subStackPop";		
			this.checkRecursion();		
			break;
		}
	}
//-----
DeepClone.prototype.subStackPop=function()
	{
	this._recurse++;
	//trace("subStackPop>");
	len=this._stack.length;
	this._stack[len-1]._subStack.pop();
	lenS=this._stack[len-1]._subStack.length;
	//
	if(lenS>0)
		{
		this._oldTgt=this._stack[len-1]._subStack[lenS-1]._oR;
		this._newTgt=this._stack[len-1]._subStack[lenS-1]._nR;
		//trace("substack reduced, checking previous item in subStack.");
		this.flow="subStackChk";		
		this.checkRecursion();
		}
	else
		{
		//trace("substack empty. recursing to previous main stack level.");
		this.flow="stackPop";		
		this.checkRecursion();
		}
	}
//-----
DeepClone.prototype.stackPop=function()
	{
	this._recurse++;
	//trace("stackPop>");
	len=this._stack.length;
	//
	if(len>1)
		{
		//trace("removing branch and going back one level");
		//trace("stackLen>"+this._stack.length);
		this._stack.pop();
		this.flow="subStackPop";		
		this.checkRecursion();
		}
	//
	else
		{
		trace("stack empty. End of DeepClone. Copy Ready.");
		this.cloneAction();
		}
	}
//-----
DeepClone.prototype.stackAdd=function()
	{
	this._recurse++;
	len=this._stack.length;
	//trace("stackAdd>"+len);
	//trace("this._newTgt:"+this._newTgt);
	//trace("--------------------");
	tgtS=this._stack[len]=new Object();
	tgtSS=tgtS._subStack=new Array();
	cnt=-1;
	//
	for(var r in this._oldTgt)
		{
		cnt++;
		tgtSS[cnt]=new Object();
		tgtSS[cnt]._oN=r;//property name
		tgtSS[cnt]._oR=this._oldTgt[r];//property reference mapping
		//trace("\_____["+r+"]-----("+this._oldTgt[r]+")");
		tOf=typeof(this._oldTgt[r]);
		//
		switch(tOf)
			{
			//
			case("object"):
				//object
				if(this._oldTgt[r].length==undefined)
					{
					//trace("[obj]");
					testEnd="";
					testRef=r.length;
					testEnd=r.substring(testRef-4);
					//
					if(len>1)
						{
						testParEnd="";
						len2=this._stack[len-1]._subStack.length;
						//trace("len2>"+len2);
						tP=this._stack[len-1]._subStack[len2-1]._oN;
						testParRef=tP.length;
						testParEnd=tP.substring(testParRef-4);
						//trace("**********"+tP+":"+testParEnd+"**********");
						}
					//T1.objects.par_pnt means theres an object, but its just a pointer, dont deepClone it
					//all things that point should have *_pnt as the ending of the variable or object reference name
					if((testEnd=="_pnt")||(testParEnd=="_pnt"))
						{
						//trace("this is only a pointer! not a real object!");
						tgtSS[cnt]._nP=true;
						this._newTgt[r]=this._oldTgt[r];
						}
					else
						{
						//trace("[[[origObj]]]"+r);
						this._newTgt[r]=new Object();
						//trace(">>>"+this._newTgt[r]);
						tgtSS[cnt]._nP=false;
						}
					}
				//array
				else
					{
					//trace("[arr]");
					this._newTgt[r]=new Array();
					tgtSS[cnt]._nP=false;
					}
				break;
			//
			case("function"):
				this._newTgt[r]=new Function(this._oldTgt[r]);
				tgtSS[cnt]._nP=false;
				break;
			//
			case("string"):
				//trace("[str]");
				this._newTgt[r]=new String(this._oldTgt[r]);
				tgtSS[cnt]._nP=false;
				break;
			//
			case("number"):
				//trace("[num]");
				this._newTgt[r]=new Number(this._oldTgt[r]);
				tgtSS[cnt]._nP=false;
				break;
			}
		tgtSS[cnt]._nN=r;
		tgtSS[cnt]._nR=this._newTgt[r];
		//trace("cnt>"+cnt);
		//trace("_nN:"+tgtSS[cnt]._nN);
		//trace("_nR:"+tgtSS[cnt]._nR);
		}
	//trace("--------------------");		
	//no sub objects
	if(cnt==-1)
		{
		trace("empty object.");
		this.flow="stackPop";		
		this.checkRecursion();		
		}
	else
		{
		//trace("new objects-----");
		//
		for(var f in this._newTgt)
			{
			//trace(f+":"+typeof(this._newTgt[f])+":"+this._newTgt[f]);
			}
		//trace("new objects-----");
		this._oldTgt=tgtSS[cnt]._oR;
		this._newTgt=tgtSS[cnt]._nR;
		//trace("<"+this._newTgt+":"+this._oldTgt);
		//trace(tgtSS[cnt]._oN);
		//trace(tgtSS[cnt]._nN);	
		this.flow="subStackChk";		
		this.checkRecursion();
		}
	}
//-----
DeepClone.prototype.checkRecursion=function()
	{
	this._recurse++;
	//trace("#"+this._recurse);
	if(this._recurse<this._recurseLim)
		{
		this[this.flow]();
		}
	//
	else
		{
		//trace("STOP!");
		pnt=15000;//timer mc depth start check 15000+
		while(_root.getInstanceAtDepth(pnt)!=undefined)
			{
			//trace("mcLevel"+pnt);
			pnt++;
			}
		//trace("pnt>"+pnt);
		this.timer1=_root.createEmptyMovieClip("recursion_dc",pnt);
		this.timer1.cnt=0;
		this.timer1.par=this;
		this.timer1.onEnterFrame=function()
			{
			this.cnt++;
			//trace(this.cnt);
			//
			if(this.cnt>1)
				{
				a=this.par;//locally scoped var a NOT in this MC, doesnt get lost after this.removeMovieClip
				this.removeMovieClip();
				a._recurse=0;
				a[a.flow]();
				}
			}		
		}
	}
//-----
DeepClone.prototype.graftCheck=function()
	{
	//are there childnodes for the sBase?
	if(this._newTgt.cn!=undefined)
		{
		exists=false;
		len=this._newTgt.length;
		//check each existing name if it matches the new name
		for(var r in this._newTgt.cn)
			{
			//
			if(r==this._baseName)
				{
				exists=true;
				}
			}
		//add the name to the end of the childnode list if it doesnt exist
		if(exists==false)
			{
			this._newTgt[len]=this._baseName;
			}
		}
	//make a childnodes array for proper grafting and references, maybe for new object later branch cloning
	else
		{
		//add the new object's name to the cn childnodes array in the sBase object
		this._newTgt.cn=new Array();
		this._newTgt.cn[0]=this._baseName;
		}
	}
//-----
DeepClone.prototype.goAddBranch=function()
	{
	this._oldTgt=this._oldTgt[this._baseName];
	this._recurse++;
	trace("goAddBranch>"+this._cType);
	//create new base object
	tOf=typeof(this._oldTgt);
	trace("tOf:"+tOf);
	//
	switch(tOf)
		{
		//
		case("object"):
			//
			if(this._oldTgt.length==undefined)
				{
				trace("[obj]");
				//
				if(this._cType=="push")
					{
					len=this._newTgt.length;
					this._newTgt[len]=new Object();
					this._newTgt=this._newTgt[len];
					}
				}
			//totally unfinished only object was finished above 03-27-2009
			else
				{
				trace("[arr]");
				this._newTgt[this._baseName]=new Array();	
				}
			//grafting
			if(this.grafting==true)
				{
				this.graftCheck();
				}			
			//
			this.flow="stackAdd";		
			this.checkRecursion();	
			break;
		//
		case("string"):
			//trace("[str]");
			this._newTgt[this._baseName]=new String(this._oldTgt);
			//grafting
			if(this.grafting==true)
				{
				this.graftCheck();
				}
			this.cloneAction();
			break;
		//
		case("number"):
			//trace("[num]");
			this._newTgt[this._baseName]=new Number(this._oldTgt);
			//grafting
			if(this.grafting==true){this.graftCheck();}			
			this.cloneAction();
			break;
		//
		case("function"):
			//trace("[function]");
			this._newTgt[this._baseName]=new Function(this._oldTgt);
			//grafting
			if(this.grafting==true){this.graftCheck();}			
			this.cloneAction();
			break;			
		//
		default:
			this.cloneAction();
			break;
		}
	}
//-----
DeepClone.prototype.goPushCopy=function()
	{
	trace("goPushCopy>");
	this._recurse++;
	tOv=typeof(this._oldTgt[this.origPoint]);
	len=this._oldTgt.length;
	trace("tOv:"+tOv);
	trace("len oldObj>"+this._oldTgt);
	//
	switch(tOv)
		{
		//
		case("object"):
			//object
			if(this._oldTgt[this.origPoint].length==undefined)
				{
				trace("new Object*");
				this._newTgt[this.pushPoint]=new Object();
				}
			//array
			else	
				{
				trace("new Array*");
				this._newTgt[this.pushPoint]=new Array();
				}
			this._oldTgt=this._oldTgt[this.origPoint];
			this._newTgt=this._newTgt[this.pushPoint];
			trace(">>>"+this._oldTgt);
			this.stackAdd();		
			break;
		//
		case("string"):
			this._newTgt[this.pushPoint]=new String(this._oldTgt[this.origPoint]);
			this.cloneAction();
			break;
		//
		case("number"):
			this._newTgt[this.pushPoint]=new Number(this._oldTgt[this.origPoint]);
			this.cloneAction();
			break;
		//
		case("function"):
			this._newTgt[this.pushPoint]=new Function(this._oldTgt[this.origPoint]);
			this.cloneAction();
			break;
		}
	}
//-----
DeepClone.prototype.go=function()
	{
	this._recurse++;
	//
	switch(this._command)
		{
		//creates a new variable with the name this._baseName
		case("addBranch"):
			this.goAddBranch();
			break;
		//
		case("pushCopy"):
			//
			this.goPushCopy();				
			break;
		//
		default:
			trace("undefined DeepClone type, error. 'sCommand'=?");
			this.cloneAction();
			break;
		}
	}
//-----
//pushCopy(base array,node to copy,new node to copy to,should new text nodes be clear?)
DeepClone.prototype.pushCopy=function(sBase,sOld,sNew,sClear)
	{
	trace("pushCopy>");
	//
	if(sBase.length!=undefined)
		{
		trace("ok. this Base is an array, a node can be copied and pushed onto its stack");
		this._newTgt=this._oldTgt=sBase;
		//just find the length of the array and copy to the end in a push with the cloned node
		if(sNew==null||sNew==undefined)
			{
			sNew=sBase.length;
			}
		//just copy the node and all text areas
		if(sClear=="null"||sClear==undefined)
			{
			this.pushClear=false;
			}			
		this.origPoint=sOld;
		this.pushPoint=sNew;
		this._command="pushCopy";
		}
	//
	else
		{
		trace("Error, this is not an array. You cannot use it to copy one node in a linear array point to another");
		}
	}
//-----
DeepClone.prototype.addBranch=function(command,oldTgt,baseNameStr,newTgt,sClear)
	{
	trace("addBranch>"+command);
	this._command="addBranch";
	this._cType=command;//what type of addBranch
	this._newTgt=newTgt;
	//
	switch(command)
		{
		//pushing the branch to the end of another object
		case("push"):
			trace("push>"+newline+"-----");
			this._oldTgt=oldTgt;
			this._baseName=baseNameStr;
			break;
		//just stitching the branch to an object
		default:
			this._oldTgt=oldTgt;
			this._baseName=baseNameStr;
			break;
		}
	}
//-----
function DeepClone()
	{
	trace("DeepClone>");
	//unless grafting is NOT desired, grafting the par - chi relationships to the new branch is desired
	//
	if(sGraft==undefined){this.grafting=true;}
	this._recurse=-1;
	this._recurseLim=32;
	this.flow="";
	this._stack=new Array();
	}